#include "info.hpp"
#include "exception.hpp"
#include "curl.hpp"

std::string
curlpp::info::effective_url()
{
   return m_effective_url;
}

long
curlpp::info::http_code()
{
   return m_http_code;
}

long
curlpp::info::file_time()
{
   return m_file_time;
}

double 
curlpp::info::total_time()
{
   return m_total_time;
}

double 
curlpp::info::namelookup_time()
{
   return m_namelookup_time;
}

double
curlpp::info::connect_time()
{
   return m_connect_time;
}

double
curlpp::info::pretransfer_time()
{
   return m_pretransfer_time;
}

double 
curlpp::info::redirect_time()
{
   return m_redirect_time;
}

long
curlpp::info::redirect_count()
{
   return m_redirect_count;
}

double
curlpp::info::size_upload()
{
   return m_size_upload;
}

double
curlpp::info::size_download()
{
   return m_size_download;
}

double
curlpp::info::speed_download()
{
   return m_speed_download;
}

double
curlpp::info::speed_upload()
{
   return m_speed_upload;
}

long 
curlpp::info::header_size()
{
   return m_header_size;
}

long
curlpp::info::request_size()
{
   return m_request_size;
}

long 
curlpp::info::ssl_verifyresult()
{
   return m_ssl_verifyresult;
}
   
curlpp::info::info(curlpp::curl &handle)
{
   CURLcode code;

   char *tmp_char;
   code = curl_easy_getinfo(handle.m_curl, CURLINFO_EFFECTIVE_URL, &tmp_char);
   curlpp::libcurl_logic_assert( "Error when retreiving effective URL", code );
   m_effective_url = tmp_char;

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_HTTP_CODE, &m_http_code);
   curlpp::libcurl_logic_assert( "Error when retreiving HTTP code", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_FILETIME, &m_file_time);
   curlpp::libcurl_logic_assert( "Error when retreiving file time", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_TOTAL_TIME, 
         &m_total_time);
   curlpp::libcurl_logic_assert( "Error when retreiving total time", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_NAMELOOKUP_TIME, 
         &m_namelookup_time);
   curlpp::libcurl_logic_assert( "Error when retreiving namelookup time", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_CONNECT_TIME, 
         &m_connect_time);
   curlpp::libcurl_logic_assert( "Error when retreiving connect time", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_PRETRANSFER_TIME, 
         &m_pretransfer_time);
   curlpp::libcurl_logic_assert( "Error when retreiving pretransfer time", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_REDIRECT_TIME,
         &m_redirect_time);
   curlpp::libcurl_logic_assert( "Error when retreiving redirect time", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_REDIRECT_COUNT,
         &m_redirect_count);
   curlpp::libcurl_logic_assert( "Error when retreiving redirect count", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_SIZE_UPLOAD,
         &m_size_upload);
   curlpp::libcurl_logic_assert( "Error when retreiving size upload", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_SIZE_DOWNLOAD,
         &m_size_download);
   curlpp::libcurl_logic_assert( "Error when retreiving size download", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_SPEED_DOWNLOAD,
         &m_speed_download);
   curlpp::libcurl_logic_assert( "Error when retreiving speed download", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_SPEED_UPLOAD,
         &m_speed_upload);
   curlpp::libcurl_logic_assert( "Error when retreiving speed upload", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_HEADER_SIZE,
         &m_header_size);
   curlpp::libcurl_logic_assert( "Error when retreiving header size", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_REQUEST_SIZE,
         &m_request_size);
   curlpp::libcurl_logic_assert( "Error when retreiving request size", code );

   code = curl_easy_getinfo(handle.m_curl, CURLINFO_SSL_VERIFYRESULT,
         &m_ssl_verifyresult);
   curlpp::libcurl_logic_assert( "Error when retreiving SSL verify result", code );
}
