#ifndef CURLPP_STREAMPOS_H
#define CURLPP_STREAMPOS_H
// Took from DDD streampos.h
// Older C++ releases defined `streampos' as a type for stream
// positions; in some compilers, this is implementation-defined.  

#include "config.h"
#include <iostream>
#include <fstream>

#if HAVE_STREAMPOS
#define STREAMPOS streampos
#elif HAVE_STD_STREAMPOS
// `streampos' is not visible, but `std::streampos' is.
#define STREAMPOS std::streampos
#else
// Use a simple `long' as replacement.
#define STREAMPOS long
#endif

#endif 
